package com.uoc.fivedevices;

import java.util.ArrayList;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.uoc.fivedevices.adaptadores.AdaptadorBDDevice;
import com.uoc.fivedevices.adaptadores.AdaptadorBDMyDevice;
import com.uoc.fivedevices.librerias.BBDDUserSession;
import com.uoc.fivedevices.librerias.Device;
import com.uoc.fivedevices.librerias.JSONManager;
import com.uoc.fivedevices.librerias.JSONParserDevices;
import com.uoc.fivedevices.librerias.MyDevice;
import com.uoc.fivedevices.librerias.UserFunctions;
import com.uoc.fivedevices.librerias.BBDDDevices;
import com.uoc.fivedevices.librerias.BBDDMyDevices;
import com.uoc.fivedevices.librerias.JSONParserMyDevices;

import android.app.Activity;
import android.app.ListActivity;
import android.content.ContentValues;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.util.Log;
import android.view.ContextMenu;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ContextMenu.ContextMenuInfo;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;
import android.widget.TextView;

public class AddDeviceWithCamera extends Activity {

	Button btnScan;
	Button btnBack;
	Button btnAdd;
	
	TextView scanResult;
	TextView marca;
	TextView modelo;
	
	String user_id;
	int deviceIdFound;
	String deviceEanFound;
	String deviceMarcaFound;
	String deviceModeloFound;
	int relationUserDeviceId;

	BBDDMyDevices dbMyDevices;
	
	public static final int REQUEST_CODE = 0x0000c0de;
	private static String KEY_SUCCESS = "success";
	
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.scan_device);
        
        
        btnScan = (Button) findViewById(R.id.btnScan);
        btnBack = (Button) findViewById(R.id.btnBack);
        btnAdd = (Button) findViewById(R.id.btnAdd);
        
        btnAdd.setEnabled(false) ;
        btnAdd.setText("Scanea algún código de barras");
        
        scanResult = (TextView) findViewById(R.id.scanResult);
        marca = (TextView) findViewById(R.id.marca);
        modelo = (TextView) findViewById(R.id.modelo);
        
        
        BBDDUserSession db2 = new BBDDUserSession(this);	//Abrimmos base de datos
	    user_id = db2.getUserUid();			//para recuperar identidad de la session
	    
	    dbMyDevices =  new BBDDMyDevices(this); //Abrimos base de datos de dispos del usuario
	    
        
	    btnBack.setOnClickListener(new View.OnClickListener() {

			public void onClick(View view) {
				finish();
			}
        });
        
	    
        btnScan.setOnClickListener(new View.OnClickListener() {

			public void onClick(View view) {
				
			/**	
			String eanPrueba = "8430848222265"; 
   	        UserFunctions userFunction = new UserFunctions();
		    JSONObject json = userFunction.SearchDeviceByEan(eanPrueba);  
		         
		        try {
					if (json.getString(KEY_SUCCESS) != null) {
						
						String res = json.getString(KEY_SUCCESS); 
						if(Integer.parseInt(res) == 1){
							
							deviceIdFound = json.getInt("_id");
							deviceEanFound = json.getString("ean");
							deviceMarcaFound = json.getString("marca");	
							deviceModeloFound = json.getString("modelo");  
							
							
							scanResult.setText("Dispositivo encontrado!");
							marca.setText(deviceMarcaFound);
					    	modelo.setText(deviceModeloFound);
					    	
					    	btnAdd.setEnabled(true) ;
					    	btnAdd.setText("Añadir " + deviceModeloFound + " a mis dispositivos");
					    		
					    	
						}
					}
		        }catch (JSONException e) {
					e.printStackTrace();}
			    **/    
		        
				Intent intent = new Intent("com.google.zxing.client.android.SCAN");
			    intent.putExtra("com.google.zxing.client.android.SCAN.SCAN_MODE", "QR_CODE_MODE");
			    intent.putExtra("PROMPT_MESSAGE", "Enfoca a algún código EAN para añadir a tus dispositivos");
			    startActivityForResult(intent, REQUEST_CODE);
			    
			    btnAdd.setEnabled(true) ;
		    	btnAdd.setText("Añadir a mis dispositivos");
		    	
				}
        });
        
        
        
        
        btnAdd.setOnClickListener(new View.OnClickListener() { //Boton para agregar a lista personal el dispo encontrado

			public void onClick(View view) {
				
				
				UserFunctions userFunction = new UserFunctions();
	 	 		JSONObject json_newDispo = userFunction.addDevice(user_id, deviceEanFound);
	 	 		
				//userFunction.addDevice(user_id, deviceEanFound);
	 	 		//JSONObject json_myDevices = userFunction.MyDevices(user_id);
	 	 		
	 	/**
				try {
		 	 	       
	 	        	JSONArray json_mydevices = json_newDispo.getJSONArray("userdevices");
	 	        	JSONParserMyDevices jsonparser = new JSONParserMyDevices(this);	
	 	        	jsonparser.parseJSONMyDevices(json_mydevices);
	 		
	 					

	 	    } catch (JSONException e) {
	 			e.printStackTrace();
	 		}**/
	 	 		
	 	 		//Ha de recuperar el identificador de la relación, que envie el servidor, para agregar a la bbdd local					
				
	 	 		//dbMyDevices.insertarDevice(relationUserDeviceId, user_id, deviceEanFound, "SinValorar!" , deviceMarcaFound, deviceModeloFound);
	 	 		//dbMyDevices.close();

				
				btnAdd.setEnabled(false);
				btnAdd.setVisibility(1);
				
			}
        });
	}
	
	
			public void onActivityResult(int requestCode, int resultCode, Intent intent) {
		    	   if (requestCode == REQUEST_CODE) {
		    	      if (resultCode == RESULT_OK) {
		    	         String contents = intent.getStringExtra("SCAN_RESULT");
		    	         //String format = intent.getStringExtra("SCAN_RESULT_FORMAT");
		    	         
		    	         //scanResult.setText(contents);
		    	         marca.setText("Encontrada Marca");
		    	         modelo.setText("Encontrado Modelo");
		    	         
		    	         
		    	         UserFunctions userFunction = new UserFunctions();
		 		         JSONObject json = userFunction.SearchDeviceByEan(contents);  
		 		         
		 		        try {
							if (json.getString(KEY_SUCCESS) != null) {
								
								String res = json.getString(KEY_SUCCESS); 
								if(Integer.parseInt(res) == 1){
									deviceEanFound = json.getString("ean");
									deviceMarcaFound = json.getString("marca");	
									deviceModeloFound = json.getString("modelo");  
									
									
									scanResult.setText("Dispositivo encontrado!");
									marca.setText(deviceMarcaFound);
					    	        modelo.setText(deviceModeloFound);
			
							    	
								}
							}
				        }catch (JSONException e) {
							e.printStackTrace();}

						
						
		    	      } else if (resultCode == RESULT_CANCELED) {
		    	    	  
		    	    	  scanResult.setText(resultCode);
			    	         marca.setText("No se ha encontrado la marca");
			    	         modelo.setText("No se ha encontrado el modelo");
			    	        
		    	         // Handle cancel
		    	      }
		    	   }
		    	   return ;
		    	}
        
			
			

       
	
	
}
