package com.uoc.fivedevices;


import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.uoc.fivedevices.adaptadores.AdaptadorBDMyContacts;
import com.uoc.fivedevices.librerias.BBDDContactos;
import com.uoc.fivedevices.librerias.BBDDDevices;
import com.uoc.fivedevices.librerias.BBDDMyContacts;
import com.uoc.fivedevices.librerias.BBDDUserSession;
import com.uoc.fivedevices.librerias.JSONParserContactos;
import com.uoc.fivedevices.librerias.UserFunctions;


import android.app.ListActivity;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.util.Log;
import android.view.ContextMenu;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ContextMenu.ContextMenuInfo;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.AdapterContextMenuInfo;


public class AmigosActivity extends ListActivity {
	/** Called when the activity is first created. */
	
	Button btnSearch;
	private static final int USERDEVICES_ID = Menu.FIRST + 1;
	private static final int DELETEFRIEND_ID = Menu.FIRST + 2;
	private static final String TAG = null;
	private AdaptadorBDMyContacts dbHelper;
	private Cursor cursor;
	long id = 0;
    
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.amigos_layout);
        
        //this.getListView().setDividerHeight(2);
        registerForContextMenu(getListView());
        btnSearch = (Button)findViewById(R.id.btnSearchFriend);
       
        
		btnSearch.setOnClickListener(new View.OnClickListener() {

			public void onClick(View view) {
				Intent mainIntent = new Intent().setClass(AmigosActivity.this, SearchFriendActivity.class);
				startActivity(mainIntent);
				//finish();//probando actualizacion
				}
        	});
        
          
        BBDDUserSession db = new BBDDUserSession(this);
        String user_session;
		user_session = db.getUserUid();//Obtenemos el identificador unico de usuario
        
		dbHelper = new AdaptadorBDMyContacts(this);
		
		
        UserFunctions userFunction = new UserFunctions();
        JSONObject json = userFunction.MyContacts(user_session);
         	
    	
        try {
            
        	JSONArray json_relation = json.getJSONArray("usersrelation");
        	JSONParserContactos jsonparser = new JSONParserContactos(this);	
        	jsonparser.parseJSONContactos(json_relation);
	
				

    } catch (JSONException e) {
		e.printStackTrace();
	}
		
		
		
        dbHelper.open();
		fillData();
		dbHelper.close();
        
		
    }
    
    
    public void onRestart() {
    	super.onRestart();
    	dbHelper.open();
		fillData();
		dbHelper.close();
    }
    
    
 	@Override
 	public void onCreateContextMenu(ContextMenu menu, View v,ContextMenuInfo menuInfo) {
 		super.onCreateContextMenu(menu, v, menuInfo);
 		
 		AdapterView.AdapterContextMenuInfo info;
 		try {
 		    info = (AdapterView.AdapterContextMenuInfo) menuInfo;
 		} catch (ClassCastException e) {
 		    Log.e(TAG, "bad menuInfo", e);
 		    return;
 		}
 			id = getListAdapter().getItemId(info.position);
 		
 		menu.add(0, USERDEVICES_ID, 0, R.string.menu_usersDevices);
 		menu.add(0, DELETEFRIEND_ID, 0, R.string.menu_deleteFriend);
 	}
 	@Override
 	public boolean onContextItemSelected(MenuItem item) {
 		
 		BBDDMyContacts devdbh = new BBDDMyContacts (this);		//Abrimos BBDD de dispos
 		SQLiteDatabase dbcontacts = devdbh.getReadableDatabase();
 		
 		
 		String[] campos = new String[]{"user1_id","user2_id","name","email"};
 		String valoritem = String.valueOf(id);
 		String[] arg = new String[]{valoritem};
 		
 		Cursor c = dbcontacts.query("mycontacts", campos, "_id=?", arg, null, null, null, null);
 		String user1_id = null;
 		String user2_id = null;
 		String name = null;
 		String email = null;

 		if(c.moveToFirst()){
 			do{
 				user1_id = c.getString(0);
 			    user2_id = c.getString(1);
 			    name = c.getString(2);
 			    email = c.getString(3);
 			    
 			}while(c.moveToNext());
 		}
 		
 		
 		
 		
 		
 		switch (item.getItemId()) {
 		case USERDEVICES_ID:
 			
 			Intent i = new Intent(AmigosActivity.this,FriendDevices.class); //creamos nueva actividad para generar la ficha
 			i.putExtra("contact_id",user2_id);
 			i.putExtra("name",name);
 			i.putExtra("email",email);
 			
 			
 			onPause();
 			startActivity(i);
 			
 			return true;
 			
 			
 			
 		case DELETEFRIEND_ID:
 			Toast.makeText(this, "Elimina el contacto", Toast.LENGTH_LONG).show();
 			return true;
 			
 			
 		}	
 		return super.onContextItemSelected(item);
 		
 	}
 	
    @Override
 	protected void onListItemClick(ListView l, View v, int position, long id) {
 		super.onListItemClick(l, v, position, id);
 		
		
 	}
    
    private void fillData() {    	
    	
 		cursor = dbHelper.fetchAllTodos();
 		startManagingCursor(cursor);

 		String[] from = new String[] { AdaptadorBDMyContacts.KEY_CNAME, AdaptadorBDMyContacts.KEY_CEMAIL };
 		//downloadFile(AdaptadorBDMyContacts.KEY_AVATAR);
 		int[] to = new int[] { R.id.name, R.id.email};
 		
 		//String[] from = new String[] { AdaptadorBDMyContacts.KEY_CNAME, AdaptadorBDMyContacts.KEY_CEMAIL, AdaptadorBDMyContacts.KEY_AVATAR};
 		//downloadFile(AdaptadorBDMyContacts.KEY_AVATAR);
 		//int[] to = new int[] { R.id.name, R.id.email, R.id.imageView1 };
 		

 		//Adaptador para desplegar cada una de las filas
 		
 		SimpleCursorAdapter notes = new SimpleCursorAdapter(this,
 				R.layout.contact, cursor, from, to );
 		setListAdapter(notes);
 		
 		}  
  
    
  /**
    void downloadFile(String imageHttpAddress) {
        URL imageUrl = null;
        try {
            imageUrl = new URL(imageHttpAddress);
            HttpURLConnection conn = (HttpURLConnection) imageUrl.openConnection();
            conn.connect();
            loadedImage = BitmapFactory.decodeStream(conn.getInputStream());
            imageView.setImageBitmap(loadedImage);
        } catch (IOException e) {
            Toast.makeText(getApplicationContext(), "Error cargando la imagen: "+e.getMessage(), Toast.LENGTH_LONG).show();
            e.printStackTrace();
        }
    }**/
}

	
	

