package com.uoc.fivedevices;


import android.app.TabActivity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.TabHost;
import android.widget.TextView;
import android.widget.TabHost.TabSpec;


import com.uoc.fivedevices.librerias.UserFunctions;
import com.uoc.fivedevices.librerias.BBDDUserSession;


public class AndroidTabLayoutActivity extends TabActivity {
    /** Called when the activity is first created. */
    
	TextView user_session; //Visualiza el nombre del usuario que se ha identificado en el Login del inicio
	UserFunctions userFunctions;
	ImageButton btnLogout;
	
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        userFunctions = new UserFunctions();
        if(userFunctions.isUserLoggedIn(getApplicationContext())){
        	
        setContentView(R.layout.mainmenu);
        
        user_session = (TextView) findViewById(R.id.user_session);
        btnLogout = (ImageButton) findViewById(R.id.btnLogout);
        
        btnLogout.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View arg0) {
				// TODO Auto-generated method stub
				userFunctions.logoutUser(getApplicationContext());
				Intent login = new Intent(getApplicationContext(), LoginActivity.class);
	        	login.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
	        	startActivity(login);
	        	// Closing dashboard screen
	        	finish();
			}
		});
        
        TabHost tabHost = getTabHost();
        
        // Pestaña con la actividad con las configuraciones de las redes sociales
        TabSpec cgspec = tabHost.newTabSpec("Social");
        cgspec.setIndicator("Social", getResources().getDrawable(R.drawable.icon_cg_tab));
        //Intent cgIntent = new Intent(this, CgActivity.class);
        Intent cgIntent = new Intent(this, SocialActivity.class);
        cgspec.setContent(cgIntent);
        
        // Pestaña con la actividad que muestra los contactos del usuario
        TabSpec friendspec = tabHost.newTabSpec("Contactos");
        friendspec.setIndicator("Contactos", getResources().getDrawable(R.drawable.icon_friends_tab));
        Intent friendsIntent = new Intent(this, AmigosActivity.class);
        //Intent friendsIntent = new Intent(this, SocialActivity.class);
        friendspec.setContent(friendsIntent);
        
        // Pestaña con la actividad que permite explorar los dispositivos que almacena el servidor 
        TabSpec explorespec = tabHost.newTabSpec("Explorar");
        explorespec.setIndicator("Explorar", getResources().getDrawable(R.drawable.icon_explore_tab));
        Intent exploreIntent = new Intent(this, ExploraActivity.class);
        explorespec.setContent(exploreIntent);
        
        // Pestaña con la actividad que muestra los dispositivos vinculados al usuario
        TabSpec mydevicespec = tabHost.newTabSpec("Mis Dispos");
        mydevicespec.setIndicator("Mis Dispos", getResources().getDrawable(R.drawable.icon_mydevices_tab));
        Intent mydevicesIntent = new Intent(this, MisDisposActivity.class);
        mydevicespec.setContent(mydevicesIntent);
        
        
        
        // Adding all TabSpec to TabHost
        tabHost.addTab(cgspec); // Adding cg tab
        tabHost.addTab(friendspec); // Adding photos tab
        tabHost.addTab(explorespec); // Adding songs tab
        tabHost.addTab(mydevicespec); // Adding videos tab
        
    
        //RECUPERA EL NOMBRE DEL USUARIO DE LA BASE DE DATOS Y LO ALMACENA EN USER_SESSION
        BBDDUserSession db = new BBDDUserSession(this);
        user_session.setText(db.getUserName());
        
        } else{
        	// user is not logged in show login screen
        	Intent login = new Intent(getApplicationContext(), LoginActivity.class);
        	login.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
        	startActivity(login);
        	// Closing screen
        	finish();
        }
    }
}