package com.uoc.fivedevices;

import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;

import org.json.JSONException;
import org.json.JSONObject;

import com.uoc.fivedevices.adaptadores.AdaptadorBDDevice;
import com.uoc.fivedevices.librerias.UserFunctions;

import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.webkit.WebView;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;


public class CameraDetails extends Activity {
	
	private static final int IO_BUFFER_SIZE = 0;
	
	private ImageView Imagen;
	private TextView Modelo;
	private TextView Marca;
	private TextView EAN;
	private TextView Resolucion;
	private TextView Sensor;
	private TextView Pantalla;
	private TextView Zoom;
	
	private TextView Web;
	private TextView Review;
	private WebView mWebView;
	
	private AdaptadorBDDevice mDbHelper;
	
	private static String KEY_SUCCESS = "success";

	private static String KEY_ERROR = "error";
	@SuppressWarnings("unused")
	private static String KEY_ERROR_MSG = "error_msg";
	
	private static String KEY_MARCA = "marca";
	private static String KEY_MODELO = "modelo";
	private static String KEY_RESOLUTION = "resolucion";
	private static String KEY_SENSOR = "sensor";
	private static String KEY_SCREEN = "pantalla";
	private static String KEY_ZOOM	 = "zoom";
	private static String KEY_WEB	 = "web";
	private static String KEY_REVIEW	 = "review";
	
	private static String KEY_IMAGEN	 = "imagen";
	

	Button btnBack;
	String ean;
	String type;
	
	String url1;
	String url_imagen;
	
	@Override
	protected void onCreate(Bundle bundle) {
		super.onCreate(bundle);
		setContentView(R.layout.camera_details);
		
		Bundle extras = getIntent().getExtras();
		if(extras !=null)
		{
		ean = extras.getString("ean");
		type = extras.getString("type");
		}
		
		btnBack = (Button) findViewById(R.id.btnBack);
			
		
		mDbHelper = new AdaptadorBDDevice(this);
		mDbHelper.open();
		
		Marca = (TextView) findViewById(R.id.detalle_marca);
		Modelo = (TextView) findViewById(R.id.detalle_modelo);
		EAN = (TextView) findViewById(R.id.detalle_ean);
		
		Imagen = (ImageView) findViewById (R.id.imageView1);
		
		
		Resolucion = (TextView) findViewById(R.id.resolucion);
		Sensor = (TextView) findViewById(R.id.sensor);
		Pantalla = (TextView) findViewById(R.id.pantalla);
		Zoom = (TextView) findViewById(R.id.zoom);
		
		Web = (TextView) findViewById(R.id.web);
		Review = (TextView) findViewById(R.id.review);
		
		EAN.setText(ean);
		
		
		//String url = "http://www.paratupc.es/productos/fotos/Canon/Canon_5047B010_POWERSHOT_SX220_HS_P.jpg";
		//String url = "http://developer.android.com/images/dialog_buttons.png";
		
		
		
		UserFunctions userFunctionDD = new UserFunctions();
        JSONObject jsonDetails = userFunctionDD.CameraDetails(ean);
        
        
        try {
			if (jsonDetails.getString(KEY_SUCCESS) != "0") {
				
				Marca.setText(jsonDetails.getString(KEY_MARCA));
				Modelo.setText(jsonDetails.getString(KEY_MODELO));
				Resolucion.setText(jsonDetails.getString(KEY_RESOLUTION));	
				Sensor.setText(jsonDetails.getString(KEY_SENSOR));
				Pantalla.setText(jsonDetails.getString(KEY_SCREEN));
				Zoom.setText(jsonDetails.getString(KEY_ZOOM));
				
				Web.setText(jsonDetails.getString(KEY_WEB));
				Review.setText(jsonDetails.getString(KEY_REVIEW));
				
				url1 = jsonDetails.getString(KEY_REVIEW);
			
				url_imagen = jsonDetails.getString(KEY_IMAGEN);
				
				mWebView = (WebView) findViewById(R.id.webview);
				
				Bitmap bimage=  getBitmapFromURL(url_imagen);
				Imagen.setImageBitmap(bimage);
				
			}else{
				if (jsonDetails.getString(KEY_ERROR) != "0") {
				Toast.makeText(this, "No se encontró la ficha del dispositivo", Toast.LENGTH_LONG).show();	
				}
			}
        }catch (JSONException e) {
			e.printStackTrace();
		}
        
        Review.setOnClickListener(new View.OnClickListener() {

			public void onClick(View view) {
				
				
				// Activo JavaScript
		        mWebView.getSettings().setJavaScriptEnabled(true);
		 
		        // Cargamos la url que necesitamos
		        mWebView.loadUrl(url1);
			}
        });
		
		btnBack.setOnClickListener(new View.OnClickListener() {

			public void onClick(View view) {
				finish();
			}
        });
		


	

		
}
	public static Bitmap getBitmapFromURL(String src) {
	    try {
	        URL url = new URL(src);
	        HttpURLConnection connection = (HttpURLConnection) url.openConnection();
	        connection.setDoInput(true);
	        connection.connect();
	        InputStream input = connection.getInputStream();
	        Bitmap myBitmap = BitmapFactory.decodeStream(input);
	        return myBitmap;
	    } catch (IOException e) {
	        e.printStackTrace();
	        return null;
	    }
	}
}

