package com.uoc.fivedevices;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.MalformedURLException;

import oauth.signpost.OAuth;
import oauth.signpost.commonshttp.CommonsHttpOAuthConsumer;
import oauth.signpost.commonshttp.CommonsHttpOAuthProvider;
import oauth.signpost.exception.OAuthCommunicationException;
import oauth.signpost.exception.OAuthExpectationFailedException;
import oauth.signpost.exception.OAuthMessageSignerException;
import oauth.signpost.exception.OAuthNotAuthorizedException;

import org.json.JSONException;
import org.json.JSONObject;

import com.facebook.android.AsyncFacebookRunner;
import com.facebook.android.AsyncFacebookRunner.RequestListener;
import com.facebook.android.Facebook;
import com.facebook.android.FacebookError;
import com.facebook.android.LoginButton;
import com.facebook.android.SessionEvents;
import com.facebook.android.SessionEvents.AuthListener;
import com.facebook.android.SessionEvents.LogoutListener;
import com.facebook.android.SessionStore;
import com.facebook.android.Util;
import com.uoc.fivedevices.librerias.BBDDUserSession;
import com.uoc.fivedevices.librerias.UserFunctions;

import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.net.Uri;
import android.os.Bundle;
import android.preference.PreferenceManager;

import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class CgActivity extends Activity {
	
	Button btnBack;
	
    public static final String APP_ID = "390228220997018"; 
    //Variable con identificador de aplicación Facebook
        
    private Button btnTwLogin;
    private OnClickListener twitter_auth, twitter_clearauth;
    
    private TextView txtFbStatus, txtTwStatus;
    private boolean twitter_active = false, facebook_active = false;    
    private AsyncFacebookRunner mAsyncRunner;
    
    /****TWITTER*****************************************************/
    private static CommonsHttpOAuthProvider provider = 
    		new CommonsHttpOAuthProvider(
            "https://api.twitter.com/oauth/request_token",
            "https://api.twitter.com/oauth/access_token",
            "https://api.twitter.com/oauth/authorize");
    
    private static CommonsHttpOAuthConsumer consumer =
    		new CommonsHttpOAuthConsumer(
    			"KRnLXppphNPOHQL66QjEBA",
    			"CUMj8HZtQd9WYRfFaI0RCYbUMbJAL9gpTJBGO0qKM");

    private static String ACCESS_KEY = null;
    private static String ACCESS_SECRET = null;
   
    /****************************************************************/
    
    
	private TextView resultado;
	//Button busca;
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.cg_layout);
        
        btnBack = (Button)findViewById(R.id.btnBack);
        
        btnBack.setOnClickListener(new View.OnClickListener(){
        	public void onClick(View view) {
        		Intent vuelta = new Intent().setClass(CgActivity.this, AndroidTabLayoutActivity.class);
				startActivity(vuelta);
				finish();
        	}
        });
        
        
        LoginButton mLoginButton = (LoginButton) findViewById(R.id.btnFbLogin);
        btnTwLogin = (Button)findViewById(R.id.btnTwLogin);

/**AL PICAR EN BUSCA SE GUARDA UN REGISTRO EN EL SERVIDOR CON LOS DATOS DEL USUARIO Y EL DISPO**/
        
        
        txtTwStatus = (TextView) this.findViewById(R.id.txtTwStatus);
        txtFbStatus = (TextView) this.findViewById(R.id.txtFbStatus);
        //resultado = (TextView) this.findViewById(R.id.resultado);
        
        
        Facebook mFacebook = new Facebook(APP_ID);
        mAsyncRunner = new AsyncFacebookRunner(mFacebook);        
                
        SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(this);
        String stored_keys = prefs.getString("KEY", "");
        String stored_secret = prefs.getString("SECRET", "");
        
        

        if (!stored_keys.equals("") && !stored_secret.equals("")) {        	
        	twitter_active = true;
        }
        
        SessionStore.restore(mFacebook, this);
        facebook_active = mFacebook.isSessionValid();
        if (facebook_active) {
        	updateFbStatus();
        }        
        
    
        SessionEvents.addAuthListener(new AuthListener() {        	
        	@Override
        	public void onAuthSucceed() {   
        		updateFbStatus();
        	}
        	
        	@Override
        	public void onAuthFail(String error) {
        		txtFbStatus.setText("Facebook status: imposible iniciar sesión " + error);        		
        	}
        });
        
        SessionEvents.addLogoutListener(new LogoutListener() {
        	
        	@Override
        	public void onLogoutFinish() {
        		txtFbStatus.setText("Facebook status: sesión no iniciada");
        	}
        	
        	@Override
        	public void onLogoutBegin() {
        		txtFbStatus.setText("Facebook status: cerrando sesión...");
        	}
        });
                
        mLoginButton.init(this, mFacebook);
        
        twitter_auth = new OnClickListener() {
			@Override
			public void onClick(View v) {    				
				txtTwStatus.setText("Twitter status: iniciando sesión");

				try {
					String authUrl = provider.retrieveRequestToken(consumer, "mdw://twitter");
					startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse(authUrl)));
				} catch (OAuthMessageSignerException e) {
					e.printStackTrace();
				} catch (OAuthNotAuthorizedException e) {
					e.printStackTrace();
				} catch (OAuthExpectationFailedException e) {
					e.printStackTrace();
				} catch (OAuthCommunicationException e) {					
					e.printStackTrace();
				}  				
				 
			}
		};
        
		twitter_clearauth = new OnClickListener() {
			@Override
			public void onClick(View v) {    	
    			SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());
    		    SharedPreferences.Editor editor = prefs.edit();    		    
    		    editor.putString("KEY", null);
    		    editor.putString("SECRET", null);
    		    editor.commit();
    		    btnTwLogin.setText("Autorizar twitter");
    		    txtTwStatus.setText("Twitter status: sesión no iniciada ");
    		    btnTwLogin.setOnClickListener(twitter_auth);
			    
			}
		};
			
        if (twitter_active) {            
        	txtTwStatus.setText("Has iniciado sesión en Twitter");
			btnTwLogin.setText("Desconectar Twitter");
            btnTwLogin.setOnClickListener(twitter_clearauth);
        } else {        	
        	btnTwLogin.setText("Conectar a Twitter");
            btnTwLogin.setOnClickListener(twitter_auth);
        }        
    } //Cierra OnCreate
    
    public void onActivityResult(int requestCode, int resultCode, Intent intent) {
        if (requestCode == 0) {
            if (resultCode == RESULT_OK) {
                String contents = intent.getStringExtra("SCAN_RESULT");
                //String format = intent.getStringExtra("SCAN_RESULT_FORMAT");
                // Handle successful scan
                resultado.setText(contents);
            } else if (resultCode == RESULT_CANCELED) {
                // Handle cancel
            }
        }
    }
    
    @Override
    public void onResume() {
    	super.onResume();
    	Uri uri = this.getIntent().getData();  
    	if (uri != null && uri.toString().startsWith("mdw://twitter")) {
    	    String verifier = uri.getQueryParameter(OAuth.OAUTH_VERIFIER);
    	    try {    	    	
    	    	provider.retrieveAccessToken(consumer,verifier);
    			ACCESS_KEY = consumer.getToken();
    			ACCESS_SECRET = consumer.getTokenSecret();
    			
    			SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(this);
    		    SharedPreferences.Editor editor = prefs.edit();    		    
    		    editor.putString("KEY", ACCESS_KEY);
    		    editor.putString("SECRET", ACCESS_SECRET);
    		    editor.commit();
    		    
    			TextView txtTwStatus = (TextView) this.findViewById(R.id.txtTwStatus);
	            txtTwStatus.setText("Has iniciado sesión en Twitter");
	            
				btnTwLogin.setText("Deautorizar twitter");
	            btnTwLogin.setOnClickListener(twitter_clearauth);

			} catch (OAuthMessageSignerException e) {
				e.printStackTrace();
			} catch (OAuthNotAuthorizedException e) {
				e.printStackTrace();
			} catch (OAuthExpectationFailedException e) {
				e.printStackTrace();
			} catch (OAuthCommunicationException e) {
				e.printStackTrace();
			}
    	    
    	} 
    	
        if (facebook_active) {
        	updateFbStatus();
        }    	
    }
    
    private void updateFbStatus(){
		mAsyncRunner.request("me", new RequestListener() {
			@Override
			public void onMalformedURLException(MalformedURLException e, Object state) {}
			
			@Override
			public void onIOException(IOException e, Object state) {}
			
			@Override
			public void onFileNotFoundException(FileNotFoundException e, Object state) {}
			
			@Override
			public void onFacebookError(FacebookError e, Object state) {}
			
			@Override
			public void onComplete(String response, Object state) {
				 try {
						JSONObject json = Util.parseJson(response);
						//final String id = json.getString("id");
						final String name = json.getString("name");
						CgActivity.this.runOnUiThread(new Runnable() {
							
							@Override
							public void run() {
								txtFbStatus.setText("Bienvenido " + name);									
							}
						});
					} catch (JSONException e) {
						e.printStackTrace();
					} catch (FacebookError e) {
						e.printStackTrace();
					}						
			}
		});
    	
    }
}