package com.uoc.fivedevices;


import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.uoc.fivedevices.adaptadores.AdaptadorBDDevice;
import com.uoc.fivedevices.librerias.JSONParserDevices;
import com.uoc.fivedevices.librerias.UserFunctions;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.webkit.WebView;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;


public class DeviceDetails extends Activity {
	
	private TextView Modelo;
	private TextView Marca;
	private TextView EAN;
	private TextView Resolucion;
	private TextView Sensor;
	private TextView Pantalla;
	private TextView Zoom;
	private TextView Review;
	private WebView mWebView;
	
	private AdaptadorBDDevice mDbHelper;
	
	private static String KEY_SUCCESS = "success";
	@SuppressWarnings("unused")
	private static String KEY_ERROR = "error";
	@SuppressWarnings("unused")
	private static String KEY_ERROR_MSG = "error_msg";
	
	private static String KEY_MARCA = "marca";
	private static String KEY_MODELO = "modelo";
	private static String KEY_RESOLUTION = "resolucion";
	private static String KEY_SENSOR = "sensor";
	private static String KEY_SCREEN = "pantalla";
	private static String KEY_ZOOM	 = "zoom";
	private static String KEY_REVIEW	 = "review";
	
	Button btnBack;
	String ean;
	String url1;
	
	@Override
	protected void onCreate(Bundle bundle) {
		super.onCreate(bundle);
		setContentView(R.layout.device_details);
		
		Bundle extras = getIntent().getExtras();
		if(extras !=null)
		{
		ean = extras.getString("ean");
		}
		
		btnBack = (Button) findViewById(R.id.btnBack);
		
		
        
		
		
		mDbHelper = new AdaptadorBDDevice(this);
		mDbHelper.open();
		
		Marca = (TextView) findViewById(R.id.detalle_marca);
		Modelo = (TextView) findViewById(R.id.detalle_modelo);
		EAN = (TextView) findViewById(R.id.detalle_ean);
		
		Resolucion = (TextView) findViewById(R.id.resolucion);
		Sensor = (TextView) findViewById(R.id.sensor);
		Pantalla = (TextView) findViewById(R.id.pantalla);
		Zoom = (TextView) findViewById(R.id.zoom);
		Review = (TextView) findViewById(R.id.review);
		
		EAN.setText(ean);
		
        
		UserFunctions userFunctionDD = new UserFunctions();
        JSONObject jsonDetails = userFunctionDD.DeviceDetails(ean);
        
        
        try {
			if (jsonDetails.getString(KEY_SUCCESS) != "0") {
				
				Marca.setText(jsonDetails.getString(KEY_MARCA));
				Modelo.setText(jsonDetails.getString(KEY_MODELO));
				Resolucion.setText(jsonDetails.getString(KEY_RESOLUTION));	
				Sensor.setText(jsonDetails.getString(KEY_SENSOR));
				Pantalla.setText(jsonDetails.getString(KEY_SCREEN));
				Zoom.setText(jsonDetails.getString(KEY_ZOOM));
				Review.setText(jsonDetails.getString(KEY_REVIEW));
				
				url1 = jsonDetails.getString(KEY_REVIEW);
			
				
				mWebView = (WebView) findViewById(R.id.webview);
				
				
			}else{
				if (jsonDetails.getString(KEY_ERROR) != "0") {
				Toast.makeText(this, "No se encontró la ficha del dispositivo", Toast.LENGTH_LONG).show();	
				}
			}
        }catch (JSONException e) {
			e.printStackTrace();
		}
        /**
        try {
            
        	JSONArray json_devices = json.getJSONArray("cameradetails");
        	JSONParserDevices jsonparser = new JSONParserDevices(this);	
        	jsonparser.parseJSONDevices(json_devices);
	
				

        } catch (JSONException e) {
		e.printStackTrace();
        }
        **/
        
        Review.setOnClickListener(new View.OnClickListener() {

			public void onClick(View view) {
				
				
				// Activo JavaScript
		        mWebView.getSettings().setJavaScriptEnabled(true);
		 
		        // Cargamos la url que necesitamos
		        mWebView.loadUrl(url1);
			}
        });
		
		btnBack.setOnClickListener(new View.OnClickListener() {

			public void onClick(View view) {
				finish();
			}
        });
}}

