package com.uoc.fivedevices;


import android.app.ListActivity;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import android.util.Log;
import android.view.ContextMenu;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ContextMenu.ContextMenuInfo;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;
import android.widget.Toast;
import com.uoc.fivedevices.adaptadores.AdaptadorBDDevice;
import com.uoc.fivedevices.librerias.BBDDUserSession;
import com.uoc.fivedevices.librerias.JSONParserDevices;
import com.uoc.fivedevices.librerias.JSONParserMyDevices;
import com.uoc.fivedevices.librerias.UserFunctions;
import com.uoc.fivedevices.librerias.BBDDDevices;


public class ExploraActivity extends ListActivity {
	
	/** Called when the activity is first created. */
	
	private static final int AGREGA_ID = Menu.FIRST + 1;
	private static final int FICHA_ID = Menu.FIRST + 2;
	private static final String TAG = null;
	private AdaptadorBDDevice dbHelper;
	private Cursor cursor;
	Button btnAudio;
	Button btnFoto;
	Button btnPhone;
	Button btnPc;
	Button btnTv;
	
	private ImageView Imagen;
	
	
	int tipo;
	long id = 0;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.explora_layout);
        
        //this.getListView().setDividerHeight(2);
        registerForContextMenu(getListView());
        
        btnAudio = (Button) findViewById(R.id.btnAudio);
        btnFoto = (Button) findViewById(R.id.btnFoto);
        btnPhone = (Button) findViewById(R.id.btnPhone);
        btnPc = (Button) findViewById(R.id.btnPc);
        btnTv = (Button) findViewById(R.id.btnTv);
        
        Imagen = (ImageView) findViewById (R.id.imageView1);
        
        
        UserFunctions userFunction = new UserFunctions();
        JSONObject json = userFunction.Devices();
        
        dbHelper = new AdaptadorBDDevice(this);
    	
    	
        try {
            
        	JSONArray json_devices = json.getJSONArray("devices");
        	JSONParserDevices jsonparser = new JSONParserDevices(this);	
        	jsonparser.parseJSONDevices(json_devices);
	
				

    } catch (JSONException e) {
		e.printStackTrace();
	}
        	
        	btnAudio.setOnClickListener(new View.OnClickListener() {

			public void onClick(View view) {
				dbHelper.open();
				fillData();
				//dbHelper.close();
				}
        	});
        	
        	btnFoto.setOnClickListener(new View.OnClickListener() {

    			public void onClick(View view) {
    				dbHelper.open();
    				fillDataFoto();
    				//dbHelper.close();
    				}
            	});
        	
        	btnPhone.setOnClickListener(new View.OnClickListener() {

    			public void onClick(View view) {
    				dbHelper.open();
    				fillDataPhone();
    				//dbHelper.close();
    				}
            	});
        	
        	btnPc.setOnClickListener(new View.OnClickListener() {

    			public void onClick(View view) {
    				dbHelper.open();
    				fillDataPc();
    				//dbHelper.close();
    				}
            	});
        	
        	btnTv.setOnClickListener(new View.OnClickListener() {

    			public void onClick(View view) {
    				dbHelper.open();
    				fillDataTv();
    				//dbHelper.close();
    				}
            	});
        	
        
        
    }
    
    public void onRestart() { //Al volver de otra actividad mantiene el estado actual
    	super.onRestart();

    }
    
    
    
 	@Override
 	public void onCreateContextMenu(ContextMenu menu, View v,ContextMenuInfo menuInfo) {
 		super.onCreateContextMenu(menu, v, menuInfo);
 		
 		AdapterView.AdapterContextMenuInfo info;
 		try {
 		    info = (AdapterView.AdapterContextMenuInfo) menuInfo;
 		} catch (ClassCastException e) {
 		    Log.e(TAG, "bad menuInfo", e);
 		    return;
 		}
 			id = getListAdapter().getItemId(info.position);
 		
 		menu.add(0, AGREGA_ID, 0, R.string.menu_agrega);
 		menu.add(0, FICHA_ID, 0, R.string.menu_ficha);
 		//menu.add(0, DELETE_ID, 0, R.string.menu_agrega);
 	}
 	@Override
 	public boolean onContextItemSelected(MenuItem item) {
 		
 			BBDDDevices devdbh = new BBDDDevices (this);		//Abrimos BBDD de dispos
	 		SQLiteDatabase db = devdbh.getReadableDatabase();
			
			BBDDUserSession db2 = new BBDDUserSession(this);	//Abrimmos base de datos
	        String user_id = db2.getUserUid();					//para recuperar identidad de la session

	 		String[] campos = new String[]{"device_id","type","marca","modelo"};
	 		String valoritem = String.valueOf(id);
	 		String[] arg = new String[]{valoritem};
	 		
	 		Cursor c = db.query("devices", campos, "_id=?", arg, null, null, null, null);
	 		String marca = null;
	 		String modelo = null;
	 		String type = null;
	 		String ean = null;
	 		if(c.moveToFirst()){
	 			do{
	 			    ean = c.getString(0);
	 			    type = c.getString(1);
	 				marca = c.getString(2);
	 			    modelo = c.getString(3);
	 			    
	 			}while(c.moveToNext());
	 		}
	 	
	 		
 		switch (item.getItemId()) {

 		case AGREGA_ID:

 	 		Toast.makeText(this, marca + " " + modelo + " añadido a tus dispositivos ", Toast.LENGTH_LONG).show();	
 	 		
 	 		UserFunctions userFunction = new UserFunctions();
 	 		JSONObject json_newDispo = userFunction.addDevice(user_id, ean);
 	 		
 	 		try {
 	 	       
 	        	JSONArray json_mydevices = json_newDispo.getJSONArray("userdevices");
 	        	JSONParserMyDevices jsonparser = new JSONParserMyDevices(this);	
 	        	jsonparser.parseJSONMyDevices(json_mydevices);
 		
 					

 	    } catch (JSONException e) {
 			e.printStackTrace();
 		}
 	 		
 			return true;
 			
 		case FICHA_ID:
 			
 			Toast.makeText(this, "type: " +type, Toast.LENGTH_LONG).show();
 			tipo = Integer.parseInt(type);
 			
 			if (tipo == 142){
 			Intent i = new Intent(ExploraActivity.this,CameraDetails.class); //creamos nueva actividad para generar la ficha
 			i.putExtra("ean",ean);
 			i.putExtra("type",type);
 
 			onPause();
 			startActivity(i);
 			return true;
 			//finish();
 			}
 			//Toast.makeText(this, "Opcion que muestra la ficha del dispositivo", Toast.LENGTH_LONG).show();
 		
 			else{
 		if (tipo == 180){
 			Intent i = new Intent(ExploraActivity.this,PhoneDetails.class); //creamos nueva actividad para generar la ficha
 			i.putExtra("ean",ean);
 			i.putExtra("type",type);
 			
 			onPause();
 			startActivity(i);
 			return true;
 			//finish();
 			}
 			//Toast.makeText(this, "Opcion que muestra la ficha del dispositivo", Toast.LENGTH_LONG).show();
 		}}
 		return super.onContextItemSelected(item);
 		
 	}
 	
    @Override
 	protected void onListItemClick(ListView l, View v, int position, long id) {
 		super.onListItemClick(l, v, position, id);
 		
 		BBDDUserSession db2 = new BBDDUserSession(this);	//Abrimmos base de datos
        String user_id = db2.getUserUid();					//para recuperar identidad de la session
 		
 		
 		BBDDDevices devdbh = new BBDDDevices (this);		//Abrimos BBDD para 
 		SQLiteDatabase db = devdbh.getReadableDatabase();
 		String[] campos = new String[]{"device_id","marca","modelo"};
 		String item = String.valueOf(id);
 		String[] arg = new String[]{item};
 		
 		Cursor c = db.query("devices", campos, "_id=?", arg, null, null, null, null);
 		String marca = null;
 		String modelo = null;
 		String ean = null;
 		if(c.moveToFirst()){
 			do{
 			    ean = c.getString(0);
 				marca = c.getString(1);
 			    modelo = c.getString(2);
 			    
 			}while(c.moveToNext());
 		}
 		Toast.makeText(this, "ID: " + id + " Cámara: " + marca + " " + modelo + " EAN: "+ ean, Toast.LENGTH_LONG).show();	
 		
 		UserFunctions userFunction = new UserFunctions();
		//userFunction.registerUser(name, email, password);
		userFunction.addDevice(user_id, ean);
 	}
    
    private void fillData() {    	
    	cursor = dbHelper.fetchAudio();
 		//cursor = dbHelper.fetchAllTodos();
 		startManagingCursor(cursor);

 		String[] from = new String[] { AdaptadorBDDevice.KEY_MARCA, AdaptadorBDDevice.KEY_MODELO};
 		int[] to = new int[] { R.id.marca, R.id.modelo };
 	

 		//Adaptador para desplegar cada una de las filas
 		
 		SimpleCursorAdapter notes = new SimpleCursorAdapter(this,
 				R.layout.row, cursor, from, to );
 		setListAdapter(notes);
 		}  
    
    private void fillDataFoto() {
    	cursor = dbHelper.fetchFoto();
 		startManagingCursor(cursor);
 		String[] from = new String[] { AdaptadorBDDevice.KEY_MARCA, AdaptadorBDDevice.KEY_MODELO};
 		int[] to = new int[] { R.id.marca, R.id.modelo };
 		//Adaptador para desplegar cada una de las filas
 		SimpleCursorAdapter notes = new SimpleCursorAdapter(this,
 				R.layout.row_camera, cursor, from, to );
 		setListAdapter(notes);
 		}  
    
    private void fillDataPhone() {
    	cursor = dbHelper.fetchPhone();
 		startManagingCursor(cursor);
 		String[] from = new String[] { AdaptadorBDDevice.KEY_MARCA, AdaptadorBDDevice.KEY_MODELO};
 		int[] to = new int[] { R.id.marca, R.id.modelo };
 		//Adaptador para desplegar cada una de las filas
 		SimpleCursorAdapter notes = new SimpleCursorAdapter(this,
 				R.layout.row, cursor, from, to );
 		setListAdapter(notes);
 		}  
    
    private void fillDataPc() {
    	cursor = dbHelper.fetchPc();
 		startManagingCursor(cursor);
 		String[] from = new String[] { AdaptadorBDDevice.KEY_MARCA, AdaptadorBDDevice.KEY_MODELO};
 		int[] to = new int[] { R.id.marca, R.id.modelo };
 		//Adaptador para desplegar cada una de las filas
 		SimpleCursorAdapter notes = new SimpleCursorAdapter(this,
 				R.layout.row, cursor, from, to );
 		setListAdapter(notes);
 		}  
    
    private void fillDataTv() {
    	cursor = dbHelper.fetchTv();
 		startManagingCursor(cursor);
 		String[] from = new String[] { AdaptadorBDDevice.KEY_MARCA, AdaptadorBDDevice.KEY_MODELO};
 		int[] to = new int[] { R.id.marca, R.id.modelo };
 		//Adaptador para desplegar cada una de las filas
 		SimpleCursorAdapter notes = new SimpleCursorAdapter(this,
 				R.layout.row, cursor, from, to );
 		setListAdapter(notes);
 		}  
}
	
	