package com.uoc.fivedevices;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;


import com.uoc.fivedevices.adaptadores.AdaptadorBDFriendDevices;
import com.uoc.fivedevices.librerias.JSONParserFriendDevices;
import com.uoc.fivedevices.librerias.UserFunctions;

import android.app.ListActivity;
import android.database.Cursor;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.SimpleCursorAdapter;
import android.widget.TextView;

public class FriendDevices extends ListActivity{

	private TextView nombre;
	private TextView email;
	private TextView friend_id;
	
	private AdaptadorBDFriendDevices dbHelper;
	
	private Cursor cursor;
	
	String contact_id;
	String name;
	String mail;
	Button btnBack;
	
	@Override
	protected void onCreate(Bundle bundle) {
		super.onCreate(bundle);
		setContentView(R.layout.contactdevices_layout);
		
		
		Bundle extras = getIntent().getExtras();
		if(extras !=null)
		{
		contact_id = extras.getString("contact_id");
		name = extras.getString("name");
		mail = extras.getString("email");
		}
		
		btnBack = (Button) findViewById(R.id.btnBack);
		
		btnBack.setOnClickListener(new View.OnClickListener() {

			public void onClick(View view) {
				finish();
			}
        });
		
		nombre = (TextView) findViewById(R.id.contact);
		email = (TextView) findViewById(R.id.email);
		//friend_id = (TextView) findViewById(R.id.contact_id);
		
		//friend_id.setText(contact_id);
		nombre.setText(name);
		email.setText(mail);
		
		UserFunctions userFunction = new UserFunctions();
        JSONObject json = userFunction.MyDevices(contact_id);

        
        try {
       
        	JSONArray json_mydevices = json.getJSONArray("userdevices");
        	JSONParserFriendDevices jsonparser = new JSONParserFriendDevices(this);	
        	jsonparser.parseJSONFriendDevices (json_mydevices);
	
				

        } catch (JSONException e) {
		e.printStackTrace();
        }
        
        dbHelper = new AdaptadorBDFriendDevices(this);
		dbHelper.open();
		fillData();
	}
	
	 private void fillData() {
	 		cursor = dbHelper.fetchAllTodos();
	 		startManagingCursor(cursor);

	 		String[] from = new String[] { AdaptadorBDFriendDevices.KEY_MARCA, AdaptadorBDFriendDevices.KEY_MODELO, AdaptadorBDFriendDevices.KEY_VALORACION};
	 		int[] to = new int[] { R.id.marca, R.id.modelo, R.id.valoracion};
	 	

	 		//Adaptador para desplegar cada una de las filas
	 		
	 		SimpleCursorAdapter notes = new SimpleCursorAdapter(this,
	 				R.layout.row_cd, cursor, from, to );
	 		setListAdapter(notes);
	 		
	 		}
	
	public void onRestart() { //Al volver de otra actividad mantiene el estado actual
		super.onRestart();}
	
}
