package com.uoc.fivedevices;

import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import com.uoc.fivedevices.librerias.BBDDUserSession;
import com.uoc.fivedevices.librerias.UserFunctions;


public class LoginActivity extends Activity {
	Button btnLogin;
	Button btnLinkToRegister;
	EditText inputEmail;
	EditText inputPassword;
	TextView loginErrorMsg;

	// Strings de la respuesta JSON que devuelve el servidor
	private static String KEY_SUCCESS = "success";
	@SuppressWarnings("unused")
	private static String KEY_ERROR = "error";
	@SuppressWarnings("unused")
	private static String KEY_ERROR_MSG = "error_msg";
	private static String KEY_UID = "uid";
	private static String KEY_NAME = "name";
	private static String KEY_EMAIL = "email";
	private static String KEY_CREATED_AT = "created_at";

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.login);

		// Importamos todos los elementos del layout, casillas de textos, botones...
		inputEmail = (EditText) findViewById(R.id.loginEmail);
		inputPassword = (EditText) findViewById(R.id.loginPassword);
		btnLogin = (Button) findViewById(R.id.btnLogin);
		btnLinkToRegister = (Button) findViewById(R.id.btnLinkToRegisterScreen);
		loginErrorMsg = (TextView) findViewById(R.id.login_error);

		// Evento al clicar en el botón Login
		btnLogin.setOnClickListener(new View.OnClickListener() {

			public void onClick(View view) {
				String email = inputEmail.getText().toString();
				String password = inputPassword.getText().toString();
				UserFunctions userFunction = new UserFunctions();
				Log.d("Button", "Login");
				JSONObject json = userFunction.loginUser(email, password);

				// Comrprobamos la respuesta del servidor al evento anterior (login)
				try {
					if (json.getString(KEY_SUCCESS) != null) {
						loginErrorMsg.setText("");
						String res = json.getString(KEY_SUCCESS); 
						if(Integer.parseInt(res) == 1){
							// El usuario se identifica correctamente
							// Y se almacenan los detalles de este usuario (devueltos por el servidor) en la base de datos
							BBDDUserSession db = new BBDDUserSession(getApplicationContext());
							JSONObject json_user = json.getJSONObject("user");
							
							// Se limpia la base de datos de información previa con la función logoutUser
							userFunction.logoutUser(getApplicationContext());
							db.addUser(json_user.getString(KEY_NAME), json_user.getString(KEY_EMAIL), json.getString(KEY_UID), json_user.getString(KEY_CREATED_AT));						
							
							// Se prepara un intent para lanzar la actividad siguiente, AndroidTabLayoutActivity
							Intent dashboard = new Intent(getApplicationContext(), AndroidTabLayoutActivity.class);
							dashboard.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
							startActivity(dashboard);
							
							// Cerramos la actividad de login
							finish();
							
						}else{
							// En caso de no producirse la identificación con los datos del servidor se muestra mensaje de error
							loginErrorMsg.setText("Nombre de usuario i/o contraseña inválidos");
						}
					}
				} catch (JSONException e) {
					e.printStackTrace();
				}
			}
		});

		// En caso de clicar en la opción de registro pasamos a la actividad RegisterActivity
		btnLinkToRegister.setOnClickListener(new View.OnClickListener() {

			public void onClick(View view) {
				Intent i = new Intent(getApplicationContext(),RegisterActivity.class);
				startActivity(i);
				finish();
			}
		});
	}
}
