package com.uoc.fivedevices;

import java.util.ArrayList;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.uoc.fivedevices.adaptadores.AdaptadorBDDevice;
import com.uoc.fivedevices.adaptadores.AdaptadorBDMyDevice;
import com.uoc.fivedevices.librerias.BBDDUserSession;
import com.uoc.fivedevices.librerias.Device;
import com.uoc.fivedevices.librerias.JSONManager;
import com.uoc.fivedevices.librerias.JSONParserDevices;
import com.uoc.fivedevices.librerias.UserFunctions;
import com.uoc.fivedevices.librerias.BBDDDevices;
import com.uoc.fivedevices.librerias.BBDDMyDevices;
import com.uoc.fivedevices.librerias.JSONParserMyDevices;

import android.app.Activity;
import android.app.ListActivity;
import android.content.ContentValues;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.util.Log;
import android.view.ContextMenu;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ContextMenu.ContextMenuInfo;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;
import android.widget.TextView;

import android.widget.Toast;


public class MisDisposActivity extends ListActivity{
	
	Button btnScan;
	Button btnUpdate;
	private AdaptadorBDMyDevice dbHelper;
	private Cursor cursor;
	private static final int VALORA_ID = Menu.FIRST + 1;
	private static final int FICHA_ID = Menu.FIRST + 2;
	private static final int ELIMINA_ID = Menu.FIRST + 4;
	private static final String TAG = null;
	long id = 0;
	
	String user_id;
	
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
    
        super.onCreate(savedInstanceState);
        setContentView(R.layout.misdispos_layout);
        registerForContextMenu(getListView());
        
        
        btnScan = (Button) findViewById(R.id.btnScan);
        btnUpdate = (Button) findViewById(R.id.btnUpdate);
          
        BBDDUserSession db2 = new BBDDUserSession(this);
        user_id = db2.getUserUid();
        
        UserFunctions userFunction = new UserFunctions();
        JSONObject json = userFunction.MyDevices(user_id);

        
        try {
       
        	JSONArray json_mydevices = json.getJSONArray("userdevices");
        	JSONParserMyDevices jsonparser = new JSONParserMyDevices(this);	
        	jsonparser.parseJSONMyDevices(json_mydevices);
	
				

    } catch (JSONException e) {
		e.printStackTrace();
	}
        
        dbHelper = new AdaptadorBDMyDevice(this);
		dbHelper.open();
		fillData(); 
		//dbHelper.close(); //prueba actualizacion
		
		
		
		
		btnUpdate.setOnClickListener(new View.OnClickListener (){
			public void onClick(View view) {					 
				dbHelper.open();
				fillData(); 
				//dbHelper.close(); //prueba actualizacion
				
			}
		});
				
		
		btnScan.setOnClickListener(new View.OnClickListener() {

			public void onClick(View view) {
				
				Intent intent = new Intent().setClass(MisDisposActivity.this, AddDeviceWithCamera.class);
				onPause();
				startActivity(intent);
			    
			    
				}
        	});
		
    }
    
    
    public void onStart() {
    	super.onRestart();
    	
    	UserFunctions userFunction = new UserFunctions();
        JSONObject json = userFunction.MyDevices(user_id);

        
        try {
       
        	JSONArray json_mydevices = json.getJSONArray("userdevices");
        	JSONParserMyDevices jsonparser = new JSONParserMyDevices(this);	
        	jsonparser.parseJSONMyDevices(json_mydevices);
	
				

    } catch (JSONException e) {
		e.printStackTrace();
	}
        
    	dbHelper.open();
		fillData(); 
		//dbHelper.close(); 
    }
    


    @Override
    public void onCreateContextMenu(ContextMenu menu, View v,ContextMenuInfo menuInfo) {
 		super.onCreateContextMenu(menu, v, menuInfo);
	 		
 		AdapterView.AdapterContextMenuInfo info;
 		try {
 		    info = (AdapterView.AdapterContextMenuInfo) menuInfo;
 		} catch (ClassCastException e) {
 		    Log.e(TAG, "bad menuInfo", e);
 		    return;
 		}
 			id = getListAdapter().getItemId(info.position);
 		
 	
 		menu.add(0, VALORA_ID, 0, R.string.menuMyDispos_valora);
 		menu.add(0, FICHA_ID, 0, R.string.menuMyDispos_ficha);
		menu.add(0, ELIMINA_ID, 0, R.string.menuMyDispos_elimina);
 	}
    
 	@Override
 	public boolean onContextItemSelected(MenuItem item) {
 		
 		
 		BBDDMyDevices devdbh = new BBDDMyDevices (this);		//Abrimos BBDD para de los dispos del usuario
	 		SQLiteDatabase db = devdbh.getReadableDatabase();
			
			BBDDUserSession db2 = new BBDDUserSession(this);	//Abrimmos base de datos
	        String user_id = db2.getUserUid();					//para recuperar identidad de la session

	 		String[] campos = new String[]{"device_id","marca","modelo"};
	 		String valoritem = String.valueOf(id);
	 		String[] arg = new String[]{valoritem};
	 		
	 		Cursor c = db.query("mydevices", campos, "_id=?", arg, null, null, null, null);
	 		String marca = null;
	 		String modelo = null;
	 		String ean = null;
	 		if(c.moveToFirst()){
	 			do{
	 			    ean = c.getString(0);
	 				marca = c.getString(1);
	 			    modelo = c.getString(2);
	 			    
	 			}while(c.moveToNext());
	 		}
 		
 		
 		switch (item.getItemId()) {
 		case VALORA_ID:
 			/**
 			BBDDMyDevices devdbh_valora = new BBDDMyDevices (this);		             //Abrimos BBDD para de los dispos del usuario
 	 		SQLiteDatabase db_valora = devdbh_valora.getReadableDatabase();
 			
 			BBDDUserSession db_user_valora = new BBDDUserSession(this);	            //Abrimmos base de datos
 	        String user_valora_id = db_user_valora.getUserUid();					//para recuperar identidad de la session
 	        
 	 		String calificacion_prueba = "Increible!";
 	 		**/
 	 		String valora_relacion = String.valueOf(id);
 	 		/**
 	 		UserFunctions userFunction_valora = new UserFunctions();
 	 		userFunction_valora.valoraDevice(valora_relacion, user_valora_id, calificacion_prueba);
 	 		
 			Toast.makeText(this, "Se actualizó  tu valoración de este dispositivos", Toast.LENGTH_LONG).show();	
 			**/
 			Intent in = new Intent(MisDisposActivity.this,ValoraDeviceActivity.class); //creamos nueva actividad para generar la ficha
 			in.putExtra("device_id",ean);
 			in.putExtra("relation_id",valora_relacion);
 			
 			
 			onPause();
 			startActivity(in);
 			return true;
 			
 		case FICHA_ID:
 			
 			Intent i = new Intent(MisDisposActivity.this,DeviceDetails.class); //creamos nueva actividad para generar la ficha
 			i.putExtra("ean",ean);
 			onPause();
 			startActivity(i);
 			return true;
 			
 		case ELIMINA_ID:
 			
 			BBDDMyDevices devdbh2 = new BBDDMyDevices (this);		//Abrimos BBDD para de los dispos del usuario
 	 		SQLiteDatabase db3 = devdbh2.getReadableDatabase();
 			
 			BBDDUserSession db4 = new BBDDUserSession(this);	//Abrimmos base de datos
 	        String user2_id = db4.getUserUid();					//para recuperar identidad de la session

 	 		
 	 		String valoritem_elimina = String.valueOf(id);
 	 		
 	 		UserFunctions userFunction_elimina = new UserFunctions();
 	 		JSONObject json = userFunction_elimina.eliminaMyDevice(user2_id, valoritem_elimina);
 	 		
 	 		try {
  	 	       
 	        	JSONArray json_mydevices = json.getJSONArray("userdevices");
 	        	JSONParserMyDevices jsonparser = new JSONParserMyDevices(this);	
 	        	jsonparser.parseJSONMyDevices(json_mydevices);
 		
 	 			} catch (JSONException e) {
 	 				e.printStackTrace();
 	 			}
 	 		
 	 		dbHelper.open();
			fillData(); 
			//dbHelper.close(); //prueba actualizacion
			
 			Toast.makeText(this, "Se ha eliminado el dispositivos de tu lista", Toast.LENGTH_LONG).show();	
 			return true;
 		}
 		return super.onContextItemSelected(item);
 		
 	}
    
		 private void fillData() {
		 		cursor = dbHelper.fetchAllTodos();
		 		startManagingCursor(cursor);

		 		String[] from = new String[] { AdaptadorBDMyDevice.KEY_MARCA, AdaptadorBDMyDevice.KEY_MODELO, AdaptadorBDMyDevice.KEY_VALORACION};
		 		int[] to = new int[] { R.id.marca, R.id.modelo, R.id.valoracion };
		 	

		 		//Adaptador para desplegar cada una de las filas
		 		
		 		SimpleCursorAdapter notes = new SimpleCursorAdapter(this,
		 				R.layout.row_md, cursor, from, to );
		 		setListAdapter(notes);
		 		
		 		}
	
		 
	public void onRestart() { //Al volver de otra actividad mantiene el estado actual
	super.onRestart();
	/**
	UserFunctions userFunction = new UserFunctions();
    JSONObject json = userFunction.MyDevices(user_id);

    
    try {
   
    	JSONArray json_mydevices = json.getJSONArray("userdevices");
    	JSONParserMyDevices jsonparser = new JSONParserMyDevices(this);	
    	jsonparser.parseJSONMyDevices(json_mydevices);

			

    } catch (JSONException e) {
	e.printStackTrace();
    }
    dbHelper.open();
	fillData();**/
	}
			
}
				
			

			
    
