package com.uoc.fivedevices;

import org.json.JSONException;
import org.json.JSONObject;
import com.uoc.fivedevices.librerias.BBDDUserSession;
import com.uoc.fivedevices.librerias.UserFunctions;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class RegisterActivity extends Activity {
	Button btnRegister;
	Button btnLinkToLogin;
	EditText inputFullName;
	EditText inputEmail;
	EditText inputPassword;
	TextView registerErrorMsg;
	
	// JSON Response node names
	private static String KEY_SUCCESS = "success";
	@SuppressWarnings("unused")
	private static String KEY_ERROR = "error";
	@SuppressWarnings("unused")
	private static String KEY_ERROR_MSG = "error_msg";
	private static String KEY_UID = "uid";
	private static String KEY_NAME = "name";
	private static String KEY_EMAIL = "email";
	private static String KEY_CREATED_AT = "created_at";

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.register);

	
		inputFullName = (EditText) findViewById(R.id.registerName);
		inputEmail = (EditText) findViewById(R.id.registerEmail);
		inputPassword = (EditText) findViewById(R.id.registerPassword);
		btnRegister = (Button) findViewById(R.id.btnRegister);
		btnLinkToLogin = (Button) findViewById(R.id.btnLinkToLoginScreen);
		registerErrorMsg = (TextView) findViewById(R.id.register_error);
		
		
		btnRegister.setOnClickListener(new View.OnClickListener() {			
			public void onClick(View view) {
				String name = inputFullName.getText().toString();
				String email = inputEmail.getText().toString();
				String password = inputPassword.getText().toString();
				UserFunctions userFunction = new UserFunctions();
				JSONObject json = userFunction.registerUser(name, email, password);
				
				// Esperamos la respuesta del servidor
				try {
					if (json.getString(KEY_SUCCESS) != null) {
						registerErrorMsg.setText("");
						String res = json.getString(KEY_SUCCESS); 
						if(Integer.parseInt(res) == 1){
							
							// Si el usuario se ha registrado correctamente
							// Almacenamos sus datos en la base de datos
							BBDDUserSession db = new BBDDUserSession(getApplicationContext());
							JSONObject json_user = json.getJSONObject("user");
							
							// Limpiamos los datos previos en la base de datos
							userFunction.logoutUser(getApplicationContext());
							db.addUser(json_user.getString(KEY_NAME), json_user.getString(KEY_EMAIL), json.getString(KEY_UID), json_user.getString(KEY_CREATED_AT));						
							
							// Pasamos a la actividad siquiente, AndroidTabLayoutActivity
							Intent dashboard = new Intent(getApplicationContext(), AndroidTabLayoutActivity.class);
							dashboard.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
							startActivity(dashboard);
							
							// Cerramos la actividad de registro
							finish();
							
							
						}else{
							// Si no es posible completar el registro se muestra el mensaje de error correspondiente
							registerErrorMsg.setText("Error. No ha sido posible realizar el registro");
						}
					}
				} catch (JSONException e) {
					e.printStackTrace();
				}
			}
		});

		// Si clicamos en el boton de login volveremos a la actividad de Login y cerramos la actividad de registro
		btnLinkToLogin.setOnClickListener(new View.OnClickListener() {

			public void onClick(View view) {
				Intent i = new Intent(getApplicationContext(),
						LoginActivity.class);
				startActivity(i);
				finish();
			}
		});
	}
}
