package com.uoc.fivedevices;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import com.uoc.fivedevices.adaptadores.AdaptadorBDContactos;
import com.uoc.fivedevices.librerias.BBDDUserSession;
import com.uoc.fivedevices.librerias.JSONParserContactos;
import com.uoc.fivedevices.librerias.UserFunctions;
import com.uoc.fivedevices.librerias.BBDDContactos;
import com.uoc.fivedevices.librerias.BBDDDevices;

import android.app.ListActivity;
import android.content.Intent;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

public class SearchFriendActivity extends ListActivity {
	
	Button btnSearch;
	Button btnBack;
	EditText searchBox;
	TextView txtFound;
	TextView txtInstrucciones;
	
	String userUidFound;
	String userIdFound;
	String userNameFound;
	String userEmailFound;
	
	private static String KEY_SUCCESS = "success";
	
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.searchfriend_layout);
        
        
        searchBox = (EditText)findViewById(R.id.searchBox);
        txtFound = (TextView)findViewById(R.id.txtFound);
        txtInstrucciones = (TextView)findViewById(R.id.txtInstrucciones);
        
        btnSearch = (Button)findViewById(R.id.btnBoxSearch);
        btnBack = (Button)findViewById(R.id.btnBack);
        

        BBDDUserSession db2 = new BBDDUserSession(this);	//Abrimmos base de datos
        final String user_session = db2.getUserUid();					//para recuperar identidad de la session
        
        final BBDDContactos dbcontactos = new BBDDContactos (this);//Abrimos BBDD contactos 
        
        btnBack.setOnClickListener(new View.OnClickListener(){
        	public void onClick(View view) {
        		
				finish();
        	}
        });
        
        btnSearch.setOnClickListener(new View.OnClickListener() {

        
			public void onClick(View view) {
				String email = searchBox.getText().toString();
				UserFunctions userFunction = new UserFunctions();
		        JSONObject json = userFunction.SearchUser(email);  
		        
		        try {
					if (json.getString(KEY_SUCCESS) != null) {
						
						String res = json.getString(KEY_SUCCESS); 
						if(Integer.parseInt(res) == 1){
							userUidFound = json.getString("uid");
							userIdFound = json.getString("unique_id");	//se recupera; el id del usuario 
							userNameFound = json.getString("name"); // nombre de usuario
							userEmailFound = json.getString("email"); // y el correo devuelto por el servidor
							
							txtFound.setText("Usuario " + email + " encontrado!");
							txtInstrucciones.setText("Clica sobre este mensaje para añadir a tus contactos");
							
							
					        
			
					    	
						}
					}
		        }catch (JSONException e) {
					e.printStackTrace();}
			}});
        
        txtInstrucciones.setOnClickListener(new View.OnClickListener() {

        
			public void onClick(View view) {
        
					UserFunctions userFunction2 = new UserFunctions();
					JSONObject json_relation = userFunction2.addRelation(user_session, userIdFound);
					
					try {
						if (json_relation.getString(KEY_SUCCESS) != null) {
							
							/***************************************************************/
							//envía json para crear evento de creación de contacto
							// user_session //identificador de usuario
							// name //nombre de usuario buscado
							
							
							
							/***************************************************************/
							
							txtInstrucciones.setText("Usuario añadido correctamente a tus contactos");	
							int uid = Integer.parseInt(userUidFound);
							dbcontactos.insertarRelacion(uid, user_session, userIdFound);
							
							
						}}catch (JSONException e) {
							e.printStackTrace();}
			}});
	}
}
					
							

