package com.uoc.fivedevices;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.ListActivity;
import android.content.Intent;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.SimpleCursorAdapter;

import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Collections;
import com.uoc.fivedevices.adaptadores.AdaptadorBDEvents;
import com.uoc.fivedevices.librerias.JSONParserEvents;
import com.uoc.fivedevices.librerias.UserFunctions;

public class SocialActivity extends ListActivity {
	
	Button btnScan;
	Button btnPerfil;
	Button btnBack;
	Button btnUpdate;
	
	private ImageView Imagen;
	String url_imagen;
	
	private AdaptadorBDEvents dbHelper;
	private Cursor cursor;
	/**
	private static final int VALORA_ID = Menu.FIRST + 1;
	private static final int FICHA_ID = Menu.FIRST + 2;
	private static final int ELIMINA_ID = Menu.FIRST + 4;
	**/
	@SuppressWarnings("unused")
	private static final String TAG = null;
	
	long id = 0;
	
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
    
        super.onCreate(savedInstanceState);
        setContentView(R.layout.social_layout);
        //registerForContextMenu(getListView());
        
        
        
        btnUpdate = (Button) findViewById(R.id.btnRefresh);
        
        btnPerfil = (Button)findViewById(R.id.btnPerfil);
        
        btnUpdate.setOnClickListener(new View.OnClickListener(){
        	public void onClick(View view) {
        		Intent vuelta = new Intent().setClass(SocialActivity.this, AndroidTabLayoutActivity.class);
				startActivity(vuelta);
				finish();
        	}
        });
        
        
        btnPerfil.setOnClickListener(new View.OnClickListener() {

			public void onClick(View view) {
				Intent perfilIntent = new Intent().setClass(SocialActivity.this, CgActivity.class);
				startActivity(perfilIntent);
				finish();
				}
        	});
        
        
		
    	UserFunctions userFunction = new UserFunctions();
        JSONObject json = userFunction.Events();

        
        try {
       
        	JSONArray json_events = json.getJSONArray("events");
        	JSONParserEvents jsonparser = new JSONParserEvents(this);	
        	jsonparser.parseJSONEvents(json_events);
	
				

    } catch (JSONException e) {
		e.printStackTrace();
	}
        
        dbHelper = new AdaptadorBDEvents(this);
		dbHelper.open();
		fillData(); 
		dbHelper.close(); //prueba actualizacion
		
		
    }

		 private void fillData() {
			    
			    //Imagen = (ImageView) findViewById (R.id.imagen_user);
			 
			    url_imagen = "http://thecontentwrangler.com/wp-content/uploads/2011/08/User.png";
				Bitmap bimage=  getBitmapFromURL(url_imagen);
				//Imagen.setImageBitmap(bimage);		
			
			 
		 		cursor = dbHelper.fetchAllTodos();
		 		startManagingCursor(cursor);

		 		String[] from = new String[] { AdaptadorBDEvents.KEY_USER1, AdaptadorBDEvents.KEY_EVENT};
		 		int[] to = new int[] { R.id.user1, R.id.evento};
		 	

		 		//Adaptador para desplegar cada una de las filas
		 		
		 		SimpleCursorAdapter notes = new SimpleCursorAdapter(this,
		 				R.layout.row_social, cursor, from, to );
		 		setListAdapter(notes);
		 		
		 		}
	
		 
	public void onRestart() { //Al volver de otra actividad mantiene el estado actual
	super.onRestart();

	}
			
	public static Bitmap getBitmapFromURL(String src) {
	    try {
	        URL url = new URL(src);
	        HttpURLConnection connection = (HttpURLConnection) url.openConnection();
	        connection.setDoInput(true);
	        connection.connect();
	        InputStream input = connection.getInputStream();
	        Bitmap myBitmap = BitmapFactory.decodeStream(input);
	        return myBitmap;
	    } catch (IOException e) {
	        e.printStackTrace();
	        return null;
	    }
	}
}
				
			

			
    

