package com.uoc.fivedevices.adaptadores;

import com.uoc.fivedevices.librerias.BBDDDevices;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;


public class AdaptadorBDDevice {

	public static final String KEY_ROWID = "_id";
	public static final String KEY_TYPE = "type";
	public static final String KEY_DEVICE = "device_id";
	public static final String KEY_MARCA = "marca";
	public static final String KEY_MODELO = "modelo";
	public static final String KEY_IMAGEN = "imagen";
	
	private static final String DATABASE_TABLE = "devices";
	private Context context;
	private SQLiteDatabase database;
	private BBDDDevices dbHelper;
	
	public AdaptadorBDDevice(Context context) {
		this.context = context;
	}
	
	public AdaptadorBDDevice open() throws SQLException {
		dbHelper = new BBDDDevices(context);
		database = dbHelper.getWritableDatabase();
		return this;
	}
	
	public void close() {
		dbHelper.close();
	}
	
	//Método para eliminar la tabla devices
		public boolean deleteTablaDevices(long rowId) {
			return database.delete(DATABASE_TABLE, KEY_ROWID + "=" + rowId, null) > 0;
		}

	//Método que retorna un cursor con todos los items 
		public Cursor fetchAllTodos() {
			return database.query(DATABASE_TABLE, new String[] { KEY_ROWID, KEY_TYPE, KEY_DEVICE,
					KEY_MARCA, KEY_MODELO, KEY_IMAGEN}, null, null, null,
					null, null);
		}
		
	//Método que retorna un cursor con los item de tipo audio
		public Cursor fetchAudio() {
			
			String[] campos = new String[] { KEY_ROWID, KEY_TYPE, KEY_DEVICE,
					KEY_MARCA, KEY_MODELO, KEY_IMAGEN};
			String[] arg = {"120"};
			
			return database.query(DATABASE_TABLE, campos , "type=?", arg, null,
					null, null);
		}		
		
	//Método que retorna un cursor con los item de tipo foto
			public Cursor fetchFoto() {
					
			String[] campos = new String[] { KEY_ROWID, KEY_TYPE, KEY_DEVICE,
							KEY_MARCA, KEY_MODELO, KEY_IMAGEN};
			String[] arg = {"142"};
					
			return database.query(DATABASE_TABLE, campos , "type=?", arg, null,
							null, null);
				}	
	//Método que retorna un cursor con los item de tipo foto
			public Cursor fetchPhone() {	
			String[] campos = new String[] { KEY_ROWID, KEY_TYPE, KEY_DEVICE,
							KEY_MARCA, KEY_MODELO, KEY_IMAGEN};
			String[] arg = {"180"};		
			return database.query(DATABASE_TABLE, campos , "type=?", arg, null,
							null, null);
				}	
	//Método que retorna un cursor con los item de tipo teléfono
			public Cursor fetchPc() {	
			String[] campos = new String[] { KEY_ROWID, KEY_TYPE, KEY_DEVICE,
							KEY_MARCA, KEY_MODELO, KEY_IMAGEN};
			String[] arg = {"152"};		
			return database.query(DATABASE_TABLE, campos , "type=?", arg, null,
							null, null);
				}
	//Método que retorna un cursor con los item de tipo televisión
			public Cursor fetchTv() {	
			String[] campos = new String[] { KEY_ROWID, KEY_TYPE, KEY_DEVICE,
							KEY_MARCA, KEY_MODELO, KEY_IMAGEN};
			String[] arg = {"148"};		
			return database.query(DATABASE_TABLE, campos , "type=?", arg, null,
							null, null);
				}
				
	//Método que devulve un cursor con la información del registro
		public Cursor fetchTodo(long rowId) throws SQLException {
			Cursor mCursor = database.query(true, DATABASE_TABLE, new String[] {
					KEY_ROWID, KEY_TYPE, KEY_DEVICE, KEY_MARCA, KEY_MODELO, KEY_IMAGEN},
					KEY_ROWID + "=" + rowId, null, null, null, null, null);
			if (mCursor != null) {
				mCursor.moveToFirst();
			}
			return mCursor;
		}
	/**	
	private ContentValues createContentValues(String marca, String modelo) {
		ContentValues values = new ContentValues();
		values.put(KEY_MARCA, marca);
		values.put(KEY_MODELO, modelo);
		return values;
	}**/
}
