package com.uoc.fivedevices.adaptadores;

import com.uoc.fivedevices.librerias.BBDDEvents;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;

public class AdaptadorBDEvents {

	public static final String KEY_ROWID = "_id";
	public static final String KEY_USER1 = "user1_id";
	public static final String KEY_EVENT = "event";
	

	
	private static final String DATABASE_TABLE = "events";
	private Context context;
	private SQLiteDatabase database;
	private BBDDEvents dbHelper;
	
	public AdaptadorBDEvents(Context context) {
		this.context = context;
	}
	
	public AdaptadorBDEvents open() throws SQLException {
		dbHelper = new BBDDEvents(context);
		database = dbHelper.getWritableDatabase();
		return this;
	}
	
	public void close() {
		dbHelper.close();
	}
	
	public long createTablaEvents(String user1_id, String event) {
		ContentValues initialValues = createContentValues(user1_id, event);

		return database.insert(DATABASE_TABLE, null, initialValues);
	}
	
	//ACTUALIZA LA TABLA DEVICES
	public boolean updateTablaEvents(long rowId, String user1_id, String event) {
			ContentValues updateValues = createContentValues(user1_id, event);

			return database.update(DATABASE_TABLE, updateValues, KEY_ROWID + "="
					+ rowId, null) > 0;
		}
	
	//ELIMINA LA TABLA DEVICE
		public boolean deleteTablaEvents(long rowId) {
			return database.delete(DATABASE_TABLE, KEY_ROWID + "=" + rowId, null) > 0;
		}

	//RETORNA UN CURSOR CON TODOS LOS ITEMS
		public Cursor fetchAllTodos() {
			return database.query(DATABASE_TABLE, new String[] { KEY_ROWID, KEY_USER1,
					KEY_EVENT}, null, null, null,
					null, null);
		}
		
	//DEVUELVE UN CURSOR CON LA INFO DEL REGISTRO
		public Cursor fetchTodo(long rowId) throws SQLException {
			Cursor mCursor = database.query(true, DATABASE_TABLE, new String[] {
					KEY_ROWID, KEY_USER1, 
					KEY_EVENT},
					KEY_ROWID + "=" + rowId, null, null, null, null, null);
			if (mCursor != null) {
				mCursor.moveToFirst();
			}
			return mCursor;
		}
		
	private ContentValues createContentValues(String user1_id, String event) {
		ContentValues values = new ContentValues();
		values.put(KEY_USER1, user1_id);
		values.put(KEY_EVENT, event);
		return values;
	}
}
