package com.uoc.fivedevices.adaptadores;

import com.uoc.fivedevices.librerias.BBDDMyDevices;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;


public class AdaptadorBDMyDevice {

	public static final String KEY_ROWID = "_id";
	public static final String KEY_MARCA = "marca";
	public static final String KEY_MODELO = "modelo";
	public static final String KEY_VALORACION = "valoration";
	private static final String DATABASE_TABLE = "mydevices";
	private Context context;
	private SQLiteDatabase database;
	private BBDDMyDevices dbHelper;
	
	public AdaptadorBDMyDevice(Context context) {
		this.context = context;
	}
	
	public AdaptadorBDMyDevice open() throws SQLException {
		dbHelper = new BBDDMyDevices(context);
		database = dbHelper.getWritableDatabase();
		return this;
	}
	
	public void close() {
		dbHelper.close();
	}
	
	public long createTablaMyDevices(String marca, String modelo, String valoracion) {
		ContentValues initialValues = createContentValues(marca, modelo, valoracion);

		return database.insert(DATABASE_TABLE, null, initialValues);
	}
	
	//ACTUALIZA LA TABLA DEVICES
	public boolean updateTablaMyDevices(long rowId, String marca, String modelo, String valoracion) {
			ContentValues updateValues = createContentValues(marca, modelo, valoracion);

			return database.update(DATABASE_TABLE, updateValues, KEY_ROWID + "="
					+ rowId, null) > 0;
		}
	
	//ELIMINA LA TABLA DEVICE
		public boolean deleteTablaMyDevices(long rowId) {
			return database.delete(DATABASE_TABLE, KEY_ROWID + "=" + rowId, null) > 0;
		}

	//RETORNA UN CURSOR CON TODOS LOS ITEMS
		public Cursor fetchAllTodos() {
			return database.query(DATABASE_TABLE, new String[] { KEY_ROWID,
					KEY_MARCA, KEY_MODELO, KEY_VALORACION}, null, null, null,
					null, null);
		}
		
	//DEVUELVE UN CURSOR CON LA INFO DEL REGISTRO
		public Cursor fetchTodo(long rowId) throws SQLException {
			Cursor mCursor = database.query(true, DATABASE_TABLE, new String[] {
					KEY_ROWID, KEY_MARCA, KEY_MODELO, KEY_VALORACION},
					KEY_ROWID + "=" + rowId, null, null, null, null, null);
			if (mCursor != null) {
				mCursor.moveToFirst();
			}
			return mCursor;
		}
		
	private ContentValues createContentValues(String marca, String modelo, String valoracion) {
		ContentValues values = new ContentValues();
		values.put(KEY_MARCA, marca);
		values.put(KEY_MODELO, modelo);
		values.put(KEY_VALORACION, valoracion);
		return values;
	}
}
