package com.uoc.fivedevices.librerias;

import java.util.ArrayList;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteDatabase.CursorFactory;
import android.database.sqlite.SQLiteOpenHelper;

public class BBDDEvents extends SQLiteOpenHelper {

	private static String name = "bbddEvents";
	private static int version = 1;
	private static CursorFactory cursorFactory = null;
	protected static String Tabla = "events";
	private String SQLCreateDevices = "CREATE TABLE " + Tabla +  " (_id INT PRIMARY KEY, user1_id VARCHAR(23), event VARCHAR(200))";
		 
	public BBDDEvents(Context context){
		 super(context,name,cursorFactory, version);
		}
	
	
	@Override
	public void onCreate(SQLiteDatabase db) {
		// TODO Auto-generated method stub
		db.execSQL(SQLCreateDevices); //SENTENCIA SQL PARA LA CREACIÓN DE LA TABLA
	}
	
	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
		// TODO Auto-generated method stub
		//db.execSQL(SQLCreateDevices); //SENTENCIA SQL PARA LA ACTUALIZACION DE LA TABLA, EN ESTE CASO CONSTRUYE DE NUEVO
		// ELIMINA LA TABLA ANTERIOR
				db.execSQL("DROP TABLE IF EXISTS " + Tabla);

				// Create tables again
				onCreate(db);
	
	}
	
	//METODO PARA ABRIR LA BASE DE DATOS
	
	public void insertarEvent(int idDevice, String User1, String Event){
		 SQLiteDatabase db = getWritableDatabase();
		 if(db!=null){
		  db.execSQL("INSERT OR REPLACE INTO " + Tabla + 
		  " (_id, user1_id, event) " +
		  " VALUES(" + idDevice + ", '" + User1 + "' '" + Event + "') ");
		  db.close();   
		 }
	}
	
	public Cursor getCursorDevice(){ //METODO PARA OPTENER EL CURSOR DE LOS REGISTROS EN LA TABLA
		SQLiteDatabase db = getReadableDatabase();
		  
		 return db.rawQuery("SELECT _id, user1_id, event "+ " FROM "+Tabla, null);  
	}
	
	public Cursor getId(){ //METODO PARA OPTENER EL CURSOR DE LOS REGISTROS EN LA TABLA
		SQLiteDatabase db = getReadableDatabase();  
		return db.rawQuery("SELECT _id FROM "+Tabla, null);  
	}
	
	
	private String SQL = ""; 
	private ArrayList<String> listSQL;
	public void addEventPoolUpdate(Event event){//METODO QUE GENERA UN ARRAYLIST CON LOS DISPOSITIVOS DE LA TABLA
		if(listSQL == null)
			listSQL = new ArrayList<String>();
			SQL = " INSERT OR REPLACE INTO events (_id, user1_id, event)  VALUES (" + event.getId() 
					+ ", '" + ReplaceQuote(event.getUser1ID())+  "', '" + ReplaceQuote(event.getEvent()) + "');";
		listSQL.add(SQL);
	}
	
	public void commitPoolUpdate(){
		if(listSQL != null && listSQL.size() > 0){
			SQLiteDatabase db = getWritableDatabase();
			if(db!=null){
				db.beginTransaction();
				for(int i = 0; i < listSQL.size();i++){
					db.execSQL(listSQL.get(i));
				}
				db.setTransactionSuccessful();
				db.endTransaction();
				db.close();
			}
			listSQL.clear();
		}
		
	}
	
	private String ReplaceQuote(String t){
		return t.replace("'", "''");
	}

	public void resetTables(){
		SQLiteDatabase db = this.getWritableDatabase();
		// 	ELIMINA LA TABLA
		db.delete(Tabla, null, null);
		db.close();
	}
}
